﻿using Kendo.Web.Models;
using Orchard.ContentManagement;
using Orchard.ContentManagement.Handlers;
using Orchard.Data;
using Orchard.Environment.Extensions;
using Orchard.Localization;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Kendo.Web.Handlers
{
    /// <summary>
    /// Add into the site options the ability to pick a global theme
    /// </summary>
    [OrchardFeature("Kendo.Web")]
    public class SiteSettingsForKendoPartHandler : ContentHandler
    {
        public SiteSettingsForKendoPartHandler(IRepository<KendoSiteSettingsPartRecord> repository)
        {
            Filters.Add(new ActivatingFilter<KendoSiteSettingsPart>("Site"));
            Filters.Add(StorageFilter.For(repository));

            T = NullLocalizer.Instance;
        }

        public Localizer T { get; set; }

        protected override void GetItemMetadata(GetContentItemMetadataContext context)
        {
            if (context.ContentItem.ContentType != "Site")
                return;

            base.GetItemMetadata(context);
            //give it its own menu section 
            context.Metadata.EditorGroupInfo.Add(new GroupInfo(T(DefinitionsAdminMenu.AdminMenuGroup)));
        }
    }
}