﻿using Orchard;
using Orchard.Data.Migration.Schema;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Orchard.ContentManagement;
using Kendo.Web.Models;

namespace Kendo.Web.MigrationTasks
{
    internal static class KendoSettings
    {
        internal static void CreateTable(SchemaBuilder schemaBuilder)
        {
            var tableRecord = typeof(KendoSiteSettingsPartRecord);

            schemaBuilder.CreateTable(tableRecord.Name, table => 
                table
                    .ContentPartRecord()
                    .Column<string>("DefaultTheme"));
        }

        public static void UpdateSiteToDefaultSettings(WorkContext value)
        {
            var part = value.CurrentSite.As<KendoSiteSettingsPart>();

            part.DefaultTheme = "Default";
        }
    }
}