using Orchard.ContentManagement.Records;
using Orchard.Environment.Extensions;
using System;

namespace Kendo.Web.Models
{
    [OrchardFeature("Kendo.UI.Scheduler")]
    public class KendoTaskPartRecord : ContentPartRecord
    {
        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        /// <value>The description.</value>
        public virtual string Description { get; set; }

        /// <summary>
        /// Gets or sets the start UTC.
        /// </summary>
        /// <value>The start UTC.</value>
        public virtual DateTime? StartUtc { get; set; }

        /// <summary>
        /// Gets or sets the end UTC.
        /// </summary>
        /// <value>The end UTC.</value>
        public virtual DateTime? EndUtc { get; set; }

        /// <summary>
        /// Gets or sets the is all day.
        /// </summary>
        /// <value>The is all day.</value>
        public virtual bool IsAllDay { get; set; }
        
        /// <summary>
        /// Gets or sets the recurrence rule.
        /// </summary>
        /// <value>The recurrence rule.</value>
        public virtual string RecurrenceRule { get; set; }
        
        /// <summary>
        /// Gets or sets the recurrence id.
        /// </summary>
        /// <value>The recurrence id.</value>
        public virtual int? RecurrenceId { get; set; }

        /// <summary>
        /// Gets or sets the recurrence exception.
        /// </summary>
        /// <value>The recurrence exception.</value>
        public virtual string RecurrenceException { get; set; }
    }
}