﻿using Orchard.Environment.Extensions.Models;
using Orchard.Security.Permissions;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Kendo.Web
{
    public class Permissions : IPermissionProvider
    {
        public static readonly Permission AccessMediaPath = new Permission { Description = "View/Edit media items with the kendo editor", Name = "Kendo media items" };

        public Feature Feature
        {
            get;
            set;
        }

        public IEnumerable<Permission> GetPermissions()
        {
            yield return AccessMediaPath;

            yield break;
        }

        public IEnumerable<PermissionStereotype> GetDefaultStereotypes()
        {
            return new[] { 
                new PermissionStereotype { 
                    Name = "Administrator", 
                    Permissions = new[] { AccessMediaPath } 
                },
                new PermissionStereotype {
                    Name = "Editor",
                    Permissions = new[] { AccessMediaPath }
                },
                new PermissionStereotype {
                    Name = "Moderator",
                    Permissions = new[] { AccessMediaPath }
                },
                new PermissionStereotype {
                    Name = "Author",
                    Permissions = new[] { AccessMediaPath }
                },
                new PermissionStereotype {
                    Name = "Contributor",
                    Permissions = new[] { AccessMediaPath }
                },
                new PermissionStereotype {
                    Name = "Authenticated",
                    Permissions = new[] { AccessMediaPath }
                }
            };
        }
    }
}
