﻿using System.Web;
using Kendo.Web.Models.FileBrowser;
using Orchard;
using System;
using System.Collections.Generic;
using System.Linq;
using Orchard.FileSystems.Media;
using Orchard.Media.Models;

namespace Kendo.Web.Services
{
    public interface IKendoImageBrowser : IDependency
    {
        IStorageFile FilePath(string path);
        MediaFolder FolderPath(string path);

        void UploadFile(string path, HttpPostedFileBase file);

        void CreateDirectory(string path, string name);

        void DeleteDirectory(string path, string name);

        void DeleteFile(string path, string name);

        bool FileExists(string path);

        bool DirectoryExists(string path);

        IEnumerable<FileBrowserEntry> GetContent(string path);
    }
}
