﻿using Kendo.Web.ViewModels;
using Orchard;
using System;
using Orchard.ContentManagement;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Kendo.Web.Models.Scheduler;

namespace Kendo.Web.Services.Scheduler
{
    public interface ITaskSchedulerService : IDependency
    {
        /// <summary>
        /// Deletes the specified id.
        /// </summary>
        /// <param name="id">The id.</param>
        void Delete(int id);

        /// <summary>
        /// Creates the data model from the specified view model.
        /// </summary>
        /// <param name="viewModel">The view model.</param>
        /// <param name="contentType">Type of the content.</param>
        /// <param name="publish">The publish.</param>
        void Create(SchedulerTaskViewModel viewModel, string contentType = null, bool publish = true);

        /// <summary>
        /// Updates the data model via the specified view model.
        /// </summary>
        /// <param name="viewModel">The view model.</param>
        void Update(SchedulerTaskViewModel viewModel);

        /// <summary>
        /// Gets the content items.
        /// </summary>
        /// <param name="queryId">The query id.</param>
        /// <param name="timeFrame">The time frame to query between.</param>
        /// <returns></returns>
        IEnumerable<ContentItem> GetContent(int queryId, TimeFrame timeFrame = null);
        
        /// <summary>
        /// Get the Total content items in the query.
        /// </summary>
        /// <param name="queryId">The query id.</param>
        /// <returns></returns>
        int Total(int queryId);
    }
}