﻿using System;
using System.Linq;

namespace Kendo.Web.ViewModels
{
    public class SchedulerTaskViewModel
    {
        /// <summary>
        /// Gets or sets the id.
        /// </summary>
        /// <value>The id.</value>
        public int TaskId { get; set; }

        /// <summary>
        /// Gets or sets the title.
        /// </summary>
        /// <value>The title.</value>
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets the description.
        /// </summary>
        /// <value>The description.</value>
        public string Description { get; set; }

        private DateTime start;
        /// <summary>
        /// Gets or sets the start.
        /// </summary>
        /// <value>The start.</value>
        public DateTime Start
        { 
            get { return start; }
            set 
            {
                start = value;
                //start = value.ToUniversalTime(); 
            }
        }

        private DateTime end;
        /// <summary>
        /// Gets or sets the end.
        /// </summary>
        /// <value>The end.</value>
        public DateTime End
        {
            get { return end; }
            set 
            {
                end = value;
                //end = value.ToUniversalTime() ; 
            }
        }

        /// <summary>
        /// Gets or sets the is all day.
        /// </summary>
        /// <value>The is all day.</value>
        public bool IsAllDay { get; set; }

        /// <summary>
        /// Gets or sets the owner id.
        /// </summary>
        /// <value>The owner id.</value>
        public int OwnerId { get; set; }

        /// <summary>
        /// Gets or sets the recurrence rule.
        /// </summary>
        /// <value>The recurrence rule.</value>
        public string RecurrenceRule { get; set; }

        /// <summary>
        /// Gets or sets the recurrence id.
        /// </summary>
        /// <value>The recurrence id.</value>
        public int? RecurrenceId { get; set; }

        /// <summary>
        /// Gets or sets the recurrence exception.
        /// </summary>
        /// <value>The recurrence exception.</value>
        public string RecurrenceException { get; set; }
    }    
}